# @pintora/standalone

<p align='center'>
  <img width="140" src="https://raw.githubusercontent.com/hikerpig/pintora/master/demo/public/img/logo.svg" alt="pintora" />
</p>
<p align='center'>
  <a href="http://pintorajs.vercel.app/docs/intro/">Documentation</a>
  <span>|</span>
  <a href="http://pintorajs.vercel.app/demo/live-editor/">Live Editor</a>
</p>

<p align='center'>
  <a href='https://www.npmjs.com/package/@pintora/standalone'>
    <img src='https://img.shields.io/npm/v/@pintora/standalone?color=ff8150&label=@pintora/standalone' />
  </a>
  <a href="https://bundlephobia.com/package/@pintora/standalone">
    <img src="https://img.shields.io/bundlephobia/min/@pintora/standalone" />
  </a>
</a>
</p>

<br>

This is a standalone version of pintora that has all the diagrams pre-bundled.

Pintora is a javascript text-to-diagrams library that works in both browser and Node.js.

Expressing your thoughts in a diagram is better than a thousand words. With the help of pintora.js, you can create diagrams with intuitive text.

Heavily inspired by [Mermaid.js](https://mermaid-js.github.io/mermaid/#/) and [PlantUML](https://plantuml.com/).

## ✨ Features

- In browser side, output SVG or Canvas.
- In Node.js side, output PNG/JPG file.
- \[Planning\] Modular and composable, load specific diagram implementaions only when needed, keep the core code lightweight.
- \[Planning\] Highly extensible, provide a plugin system for diagram developer to write and distribute their own diagrams.

### Diagram types

- Sequence Diagram
- Entity Relationship Diagram
- Component Diagram
- Activity Diagram
- Mind Map
- Gantt Diagram

<table>
  <thead>
    <tr>
      <th>name</th>
      <th>preview</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td>Sequence Diagram</td>
      <td>
        <img src="https://i.imgur.com/6CMLz7C.jpg" title="Sequence Diagram" width="300" />
      </td>
    </tr>
    <tr>
      <td>Entity Relationship Diagram</td>
      <td>
        <img src="https://i.imgur.com/o31ydlQ.jpg" title="Entity Relationship Diagram" width="300" />
      </td>
    </tr>
    <tr>
      <td>Component Diagram</td>
      <td>
        <img src="https://i.imgur.com/yk68Ot5.jpg" title="Component Diagram" width="300" />
      </td>
    </tr>
    <tr>
      <td>Activity Diagram</td>
      <td>
        <img src="https://i.imgur.com/HoMe3Gp.jpg" title="Activity Diagram" width="300" />
      </td>
    </tr>
    <tr>
      <td>Mind Map</td>
      <td>
        <img src="https://i.imgur.com/jT6HQg6.jpg" title="Mind Map" width="300" />
      </td>
    </tr>
    <tr>
      <td>Gantt Diagram</td>
      <td>
        <img src="https://i.imgur.com/hwcK3cT.jpg" title="Gantt Diagram" width="300" />
      </td>
    </tr>
  </tbody>
</table>

## 📖 Documentation

Check the online [documentation and demo](http://pintorajs.vercel.app/) for more details.
